# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define _with_repolib 1

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'
%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/jboss/remoting/%{version}.%{reltag}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

# FIXME
%define _without_tests 1

# If you don't want to run the unit tests
# give rpmbuild option '--without tests'

%define with_tests %{!?_without_tests:1}%{?_without_tests:0}
%define without_tests %{?_without_tests:1}%{!?_without_tests:0}


%define section free

%define reltag  SP4

Summary:        JBoss Remoting
URL:            http://labs.jboss.com/portal/index.html?ctrl:id=page.default.info&project=jbossremoting
# svn export https://svn.jboss.org/repos/jbossremoting/remoting2/tags/2.2.2-SP4 JBossRemoting
# tar czf jboss-remoting-2.2.2.SP4-src.tar.gz JBossRemoting
Source0:        jboss-remoting-2.2.2.SP4-src.tar.gz
# FIXME We need to update this patch to force IPv4 to be used on Linux
Patch0:         jboss-remoting-1.4.3-build_xml.patch
Source1:	jboss-remoting-component-info.xml

Name:           jboss-remoting
Version:        2.2.2
Release:        3.SP4.0jpp.ep1.1%{?dist}
Epoch:          0
License:        LGPL
Group:          Development/Java
BuildArch:      noarch
BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:  ant >= 0:1.6
BuildRequires:  junit
BuildRequires:  jboss-jrunit
BuildRequires:	batik
BuildRequires:	fop
BuildRequires:	saxon

BuildRequires:  concurrent
BuildRequires:  dom4j
BuildRequires:  jakarta-commons-httpclient
BuildRequires:  jakarta-commons-logging
BuildRequires:  log4j
BuildRequires:  tomcat5-server-lib >= 0:5.5.16-3jpp
BuildRequires:  tomcat5-servlet-2.4-api
BuildRequires:  jboss-common
#BuildRequires:	jboss4-jmx
#BuildRequires:	jboss4-naming ??? not used?
# Instead, use jbossas
BuildRequires:  jbossas
BuildRequires:  jboss-serialization
BuildRequires:  jgroups >= 0:2.2.9.2
BuildRequires:  jcommon
BuildRequires:  jfreechart
BuildRequires:  spring
BuildRequires:  aopalliance
BuildRequires:  hessian
BuildRequires:  gnu-trove

Requires:       jpackage-utils >= 0:1.6
Requires:       concurrent
Requires:       dom4j
Requires:       jakarta-commons-httpclient
Requires:       jakarta-commons-logging
Requires:       log4j
# EAP only - JBoss Remoting will be deployed on a server that will have
# all the necessary bits
#Requires:       tomcat5-server-lib >= 0:5.5.17
Requires:       tomcat5-servlet-2.4-api
Requires:       jboss-common
Requires:       jboss-serialization
Requires:       jgroups >= 0:2.2.9.2
Requires:       jcommon
Requires:       jfreechart

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
The purpose of JBoss Remoting is to provide a single API for most 
network based invocations and related service that uses pluggable 
transports and data marshallers. The JBoss Remoting API provides 
the ability for making synchronous and asynchronous remote calls, 
push and pull callbacks, and automatic discovery of remoting servers. 
The intention is to allow for the addition of different transports 
to fit different needs, yet still maintain the same API for making 
the remote invocations and only requiring configuration changes, 
not code changes, to fit these different needs.

%if %{with_repolib}
%package	 repolib
Summary:	 Artifacts to be uploaded to a repository library
Group:	Development/Libraries/Java

%description	 repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}

%package demo
Summary:        Usage examples for %{name}
Group:          Development/Documentation

%description demo
%{summary}

%prep
%setup -q -n JBossRemoting
chmod -R go=u-w *
for j in $(find . -name "*.jar"); do
    rm $j
done

# FIXME
#%patch0 -b .sav

sed -i 's/@VERSION@/%{version}.%{reltag}-brew/g' %{SOURCE1}
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{SOURCE1}

%build
#docs/guide/support/support/lib/avalon-framework-cvs-20020806.jar.no
#docs/guide/support/support/lib/batik.jar.no
#docs/guide/support/support/lib/fop.jar.no
#docs/guide/support/support/lib/jai_codec.jar.no
#docs/guide/support/support/lib/jai_core.jar.no
#docs/guide/support/support/lib/rowan-0.1.jar.no
#docs/guide/support/support/lib/saxon-dbxsl-extensions.jar.no
#docs/guide/support/support/lib/saxon.jar.no
pushd docs/guide/support/support/lib
build-jar-repository -s -p . \
batik \
fop \
saxon
popd
#lib/apache-commons/lib/commons-httpclient.jar.no
#lib/apache-commons/lib/commons-logging-api.jar.no
pushd lib/apache-commons/lib
ln -sf $(build-classpath commons-httpclient) .
ln -sf $(build-classpath commons-logging-api) .
popd
#lib/apache-log4j/lib/log4j.jar.no
pushd lib/apache-log4j/lib
ln -sf $(build-classpath log4j) .
popd
#lib/apache-tomcat/tomcat-apr.jar.no
#lib/apache-tomcat/tomcat-coyote.jar.no
#lib/apache-tomcat/tomcat-http.jar.no
#lib/apache-tomcat/tomcat-util.jar.no
pushd lib/apache-tomcat
ln -sf $(build-classpath tomcat5/tomcat-apr) .
ln -sf $(build-classpath tomcat5/tomcat-coyote) .
ln -sf $(build-classpath tomcat5/tomcat-http) .
ln -sf $(build-classpath tomcat5/tomcat-util) .
popd
#lib/dom4j/lib/dom4j.jar.no
pushd lib/dom4j/lib
ln -sf $(build-classpath dom4j) .
popd
#lib/jboss/jboss-common.jar.no
#lib/jboss/jboss-jmx.jar.no
#lib/jboss/jboss-serialization.jar.no
#lib/jboss/jnpserver.jar.no
#lib/jboss/jrunit.jar.no
pushd lib/jboss
ln -sf $(build-classpath jboss-common/jboss-common) .
ln -sf $(build-classpath jbossas/jboss-jmx) .
ln -sf $(build-classpath jbossas/jnpserver) .
ln -sf $(build-classpath jboss-jrunit) .
ln -sf $(build-classpath jboss-serialization) .
popd
#lib/jgroups/lib/jgroups.jar.no
pushd lib/jgroups/lib
ln -sf $(build-classpath jgroups) .
popd
#lib/jrunit-libs/lib/jcommon-1.0.0-rc1.jar.no
#lib/jrunit-libs/lib/jfreechart-1.0.0-rc1.jar.no
pushd lib/jrunit-libs/lib
ln -sf $(build-classpath jcommon) .
ln -sf $(build-classpath jfreechart) .
popd
#lib/junit/lib/junit.jar.no
pushd lib/junit/lib
ln -sf $(build-classpath junit) .
popd
#lib/oswego-concurrent/lib/concurrent.jar.no
pushd lib/oswego-concurrent/lib
ln -sf $(build-classpath concurrent) .
popd
#lib/spring/aopalliance/aopalliance.jar.no
pushd lib/spring/aopalliance
ln -sf $(build-classpath aopalliance) .
popd
#lib/spring/spring*.jar.no
pushd lib/spring
build-jar-repository . spring
popd
#lib/spring/caucho/hessian-2.1.12.jar.no
pushd lib/spring/caucho
ln -sf $(build-classpath hessian) .
popd
#lib/sun-servlet/lib/servlet-api.jar.no
pushd lib/sun-servlet/lib
ln -sf $(build-classpath servletapi5) servlet-api.jar
popd
#lib/trove/lib/trove.jar.no
pushd lib/trove/lib
ln -sf $(build-classpath gnu-trove) trove.jar
popd

%if %{with_tests}
export ANT_OPTS="-Djava.net.preferIPv4Stack=true"
ant -Dcompile.source="1.4" -Dcompile.target="1.4" jars javadoc tests
%else
ant -Dcompile.source="1.4" -Dcompile.target="1.4" jars javadoc
%endif

%install
rm -rf $RPM_BUILD_ROOT

# jar
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}
install -p -m 0644 output/lib/jboss-remoting.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# etc
install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
cp -pr output/etc   $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
rm -fr $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc/lib
cp -pr output/lib/servlet-invoker.war   $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
# FIXME ???
#cp -p docs/JBossRemotingPushCallbacks.sxd $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr output/doc/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}

# manual
install -d -m 0755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr docs/*   $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
# FIXME ???
#install -d -m 0755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/Multiplex
#cp -pr docs/Multiplex/build/en/*   $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/Multiplex
#cp -p docs/multiplex.pdf   $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/Multiplex


%if %{with_repolib}
	install -d -m 755 $RPM_BUILD_ROOT%{repodir}
	install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
	install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{repodir}/component-info.xml
	install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
	cp $RPM_BUILD_ROOT%{_javadir}/jboss-remoting.jar $RPM_BUILD_ROOT%{repodirlib}
        # Add the source again for some eclipse jboss project use
        tar xzf  %{SOURCE0}
        pushd JBossRemoting/src/main
        zip -r $RPM_BUILD_ROOT%{repodirlib}/jboss-remoting-src.jar org
        popd
        chmod 755 $RPM_BUILD_ROOT%{repodirlib}/jboss-remoting-src.jar
        rm -fr JBossRemoting
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%dir %{_javadir}
%{_javadir}/*jar
%{_datadir}/%{name}-%{version}/etc
%{_datadir}/%{name}-%{version}/servlet-invoker.war
# FIXME ???
#%{_datadir}/%{name}-%{version}/JBossRemotingPushCallbacks.sxd

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}


%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{repodir}
%endif

%changelog
* Wed Dec 12 2007 Fernando Nasser <fnasser@redhat.com> 0:2.2.2-3.SP4.0jpp.ep1.1
- Upgrade to SP4

* Thu Dec 06 2007 Fernando Nasser <fnasser@redhat.com> 0:2.2.2-3.SP3.0jpp.ep1.1
- Upgrade to SP3

* Wed Nov 28 2007 Fernando Nasser <fnasser@redhat.com> 0:2.2.2-2.GA_CP02.0jpp.ep1.2
- Rebuild with JDK 1.4

* Wed Nov 28 2007 Fernando Nasser <fnasser@redhat.com> 0:2.2.2-2.GA_CP02.0jpp.ep1.1
- Upgrade to CP02

* Mon Nov 26 2007 Fernando Nasser <fnasser@redhat.com> 0:2.2.2-2.GA_CP01.0jpp.ep1.3
- Specify target JDK 1.4 for building

* Wed Oct 24 2007 Fernando Nasser <fnasser@redhat.com> 0:2.2.2-2.GA_CP01.0jpp.ep1.2
- Leave only the main sources in the lib directory src JAR
- Add it as an artifact

* Wed Oct 24 2007 Fernando Nasser <fnasser@redhat.com> 0:2.2.2-2.GA_CP01.0jpp.ep1.1
- Upgrade to GA_CP01

* Tue Oct 02 2007 Fernando Nasser <fnasser@redhat.com> 0:2.2.2-1.SP1.0jpp.ep1.2
- Add patch for JBREM-811 (needed by JBM)

* Fri Sep 14 2007 Fernando Nasser <fnasser@redhat.com> 0:2.2.2-1.SP1.0jpp.ep1.1
- Upgrade to SP1
- Build with JDK 1.5 due to dependency on jbossas (which is built with JDK 1.5)

* Mon Sep 10 2007 Fernando Nasser <fnasser@redhat.com> 0:2.2.2-1jpp.ep1.5
- Specify target JDK 1.4 for building

* Fri Sep 07 2007 Fernando Nasser <fnasser@redhat.com> 0:2.2.2-1jpp.ep1.4
- Relax run-time dependencies

* Thu Aug 30 2007 Fernando Nasser <fnasser@redhat.com> 0:2.2.2-1jpp.ep1.3
- Fix Eclipse source JAR

* Wed Aug 29 2007 Fernando Nasser <fnasser@redhat.com> 0:2.2.2-1jpp.ep1.2
- Remove unversioned javadoc dir
- Clean up old remoting JARs in etc/lib subdir and remove that dir

* Fri Aug 24 2007 Fernando Nasser <fnasser@redhat.com> 0:2.2.2-1jpp.ep1.1
- Upgrade to 2.2.2.GA

* Wed Aug 15 2007 Deepak Bhole <dbhole@redhat.com> 0:2.2.0.4-1.CP02.1jpp.ep1.3
- Added compatible version 1.0.3.GA-brew for jboss-serialization

* Wed Aug 15 2007 Deepak Bhole <dbhole@redhat.com> 0:2.2.0.4-1.CP02.1jpp.ep1.2
- Fixed incorrect version in component info
- Fixed file/dir ownerships

* Mon Jul 30 2007 Fernando Nasser <fnasser@redhat.com> 0:2.2.0-1.SP4_CP02.1jpp.ep1.1
- Adjust release tag to new std format
- Specify target JDK 1.4 for building

* Tue Jul 24 2007 Fernando Nasser <fnasser@redhat.com> 0:2.2.0.4-1.CP02.1jpp.ep1.1
- Merge with upstream for upgrade

* Tue Jul 24 2007 Fernando Nasser <fnasser@redhat.com> 0:2.2.0.4-1.CP02.1jpp
- Upgrade to 2.2.0.SP4_CP02
- Fix release tag to new guidelines

* Fri Jun 22 2007 Fernando Nasser <fnasser@redhat.com> 0:2.2.0.4.1-1jpp.ep1.2
- Add missing quote to component-info.xml
- Add -src file under lib for some jboss eclipse project use

* Fri Jun 22 2007 Fernando Nasser <fnasser@redhat.com> 0:2.2.0.4.1-1jpp.ep1.1
- Merge with upstream for upgrade
- Add repolib subpackage
- Do not run the tests this time (FIXME)

* Fri Jun 22 2007 Fernando Nasser <fnasser@redhat.com> 0:2.2.0.4.1-1jpp
- Upgrade to 2.2.0.SP4_CP01

* Thu Mar 15 2007 Ralph Apel <r.apel at r-apel.de> 0:1.4.1-3jpp
- (B)R jcommon0, jfreechart0

* Tue Jul 11 2006 Fernando Nasser <fnasser@redhat.com> 0:1.4.3-2jpp_1rh
- Merge with upstream
- Do not run the tests this time (FIXME)

* Mon Jun 26 2006 Ralph Apel <r.apel at r-apel.de> 0:1.4.3-2jpp
- Fix (Build)Requires:
- Set -Djava.net.preferIPv4Stack=true everywhere 
- Fix manual generation and subpackage

* Mon Jun 12 2006 Ralph Apel <r.apel at r-apel.de> 0:1.4.3-1jpp
- First JPP-5.0 release

* Wed May 31 2006 Ralph Apel <r.apel at r-apel.de> 0:1.4.1-2jpp
- add -Djava.net.preferIPv4Stack=true for all JVMs
- fix bad lib replacement for tomcat5 libs

* Fri May 26 2006 Fernando Nasser <fnasser@redhat.com> 0:1.4.1-1jpp_2rh
- Obsolete old jboss4-remoting package
- Do not run the tests this time

* Fri May 26 2006 Fernando Nasser <fnasser@redhat.com> 0:1.4.1-1jpp_1rh
- First Red Hat build

* Wed May 03 2006 Ralph Apel <r.apel at r-apel.de> 0:1.4.1-1jpp
- First JPP-1.7 release
